;=============================================================================
; Insight, real-mode debugger for MS DOS / PC DOS / FreeDOS.
; Copyright (c) Victor M. Gamayunov, Sergey Pimenov, 1993, 96, 97, 2002.
; Modifications by Oleg O. Chukaev (2006 - 2009).
;-----------------------------------------------------------------------------
; config.inc
; Configuration dialog.
;-----------------------------------------------------------------------------
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
; 02110-1301 USA
;=============================================================================

open_config:
	mov byte [config_dlg_item], 0

	mov ax, word [portnumber]
	mov di, portnumber_string
	call fill_word_str
	mov al, 0
	stosb

	mov ax, word [intnumber]
	mov di, intnumber_string
	call fill_byte_str
	mov al, 0
	stosb

	mov ax, word [irqmask]
	mov di, irqmask_string
	call fill_word_str
	mov al, 0
	stosb

		mov	ax, 7
		call	init_string_list

	mov si, baudstrings
@@next:
		mov	al,' '
		mov	cx, 6
		mov	di,string
	rep	stosb
		mov	byte [es:di],0

	mov di, string
	call strlen
	rep movsb
	inc si

	push si
		mov	si,string
		call	add_string	;Add string to list
	pop si
	cmp si, baudstrings.end
	jb @@next

.loop:
	mov ax, [baudlistchoice]
	mov word [active_list_choice], ax

	mov si, config_dialog
	call init_dialog
	call exec_dialog_
	cmp ax, CM_CANCEL
	je .noserial
	cmp ax, 3
	je .redraw

	mov ax, [list_choice]
	cmp ax, -1
	je @F
	mov word [baudlistchoice], ax
	call get_string_addr
	xchg ax, si
	mov al, '1'
	cmp word [si], "12"
	je .gotbaud
	mov al, '2'
	cmp word [si], "24"
	je .gotbaud
	mov al, '3'
	cmp word [si], "48"
	je .gotbaud
	mov al, '4'
	cmp word [si], "96"
	je .gotbaud
	mov al, '5'
	cmp word [si], "19"
	je .gotbaud
	mov al, '6'
	cmp word [si], "38"
	je .gotbaud
	mov al, '7'
	cmp word [si], "57"
	je .gotbaud
	mov al, '8'
	; cmp word [si], "11"
	; je .gotbaud
.gotbaud:
	mov byte [baud], al
@@:

	mov di, sp

	mov si, portnumber_string
	call get_hex_value
	jc .invalid
	cmp byte [si], 0
	jne .invalid
	push bx

	mov si, intnumber_string
	call get_hex_value
	jc .invalid
	cmp byte [si], 0
	jne .invalid
	push bx

	mov si, irqmask_string
	call get_hex_value
	jc .invalid
	cmp byte [si], 0
	jne .invalid
	mov word [irqmask], bx
	pop word [intnumber]
	pop word [portnumber]

.noserial:
	call initialise_draw_table
	call draw_screen
	retn

.invalid:
	mov sp, di
	mov si, serialnumber_error_msg
	call _error_message
	jmp .loop

.redraw:
	call initialise_draw_table
	call draw_screen
	jmp .loop

redraw_config_change:
	mov ax, 3
	stc
	retn
